const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const interviews = sequelize.define(
    'interviews',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      type: {
        type: DataTypes.ENUM,

        values: ['Phone', 'Onsite', 'Virtual'],
      },

      scheduled_at: {
        type: DataTypes.DATE,
      },

      rating: {
        type: DataTypes.DECIMAL,
      },

      notes: {
        type: DataTypes.TEXT,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  interviews.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    //end loop

    db.interviews.belongsTo(db.applications, {
      as: 'application',
      foreignKey: {
        name: 'applicationId',
      },
      constraints: false,
    });

    db.interviews.belongsTo(db.employees, {
      as: 'interviewer',
      foreignKey: {
        name: 'interviewerId',
      },
      constraints: false,
    });

    db.interviews.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });

    db.interviews.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.interviews.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return interviews;
};
